#ifndef __TYPE_SIZES_H
#define __TYPE_SIZES_H

#ifdef _WIN32
#include <windows.h>
#else
#include "wintypes.h"
#endif

/*
 *   unsigned types
 *
 */
	
/* these are (very) often used */
#define _u64      unsigned __int64   /* 64 bit */
#define _u32        unsigned __int32   /* 16 bit */
#define _u16	    unsigned __int16   /* 16 bit */
#define _u8			unsigned __int8    /*  8 bit */

/* these are (very) often used */
#define _s64      __int64    /* 64 bit */
#define _s32       __int32    /* 16 bit */
#define _s16      __int16    /* 16 bit */
#define _s8      __int8	   /*  8 bit */


#endif
